'From MIT Squeak 0.9.4 (June 1, 2003) [No updates present.] on 17 August 2011 at 10:23:22 pm'!
StringMorph subclass: #MenuItemMorph
	instanceVariableNames: 'isInTransition isEnabled subMenu isSelected target selector arguments icon '
	classVariableNames: 'SubMenuMarker '
	poolDictionaries: ''
	category: 'Morphic-Menus'!

!MenuItemMorph methodsFor: 'drawing' stamp: 'jens 3/27/2009 09:37'!
drawOn: aCanvas
	| selectionColor px py |
	isSelected & isEnabled
		ifTrue:
			[selectionColor _ Display depth <= 2
				ifTrue: [Color gray]
				ifFalse: [owner color darker].
			aCanvas fillRectangle: self bounds color: selectionColor].
	super drawOn: aCanvas.
	subMenu ifNotNil:
		[aCanvas
			paintImage: SubMenuMarker
			at: self right - 8 @ (self top + self bottom - SubMenuMarker height // 2)].
	icon ifNotNil: [
		px _ self width - icon width // 2.
		py _ self height - icon height // 2.
		aCanvas
			paintImage: icon
			at: self position + (px @ py )]
		! !

!MenuItemMorph methodsFor: 'layout' stamp: 'jens 3/25/2009 03:48'!
layoutInWidth: w height: h

	icon ifNotNil: [^self extent: ((icon extent) max: w@h) ].
	self extent: ((self stringExtent: contents) max: w@h).

! !

!MenuItemMorph methodsFor: 'layout' stamp: 'jens 3/27/2009 09:38'!
minHeight

	icon ifNotNil: [^icon height + 2].
	^ self extent y
! !

!MenuItemMorph methodsFor: 'layout' stamp: 'jens 3/27/2009 09:38'!
minWidth

	icon ifNotNil: [^icon width + 2].
	^ (self stringWidth: contents) + (subMenu == nil ifTrue: [0] ifFalse: [10])
! !

!MenuItemMorph methodsFor: 'private' stamp: 'jens 3/25/2009 03:40'!
icon: aForm 
	icon _ aForm.! !


!MenuMorph methodsFor: 'construction' stamp: 'jens 3/27/2009 09:42'!
addIcon: aForm tooltip: aString action: aSymbol
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object with the given arguments. If the selector takes one more argument than the number of arguments in the given list, then the triggering event is supplied as as the last argument."

	self addIcon: aForm 
		tooltip: aString 
		target: defaultTarget 
		selector: aSymbol 
		argumentList: Array empty
! !

!MenuMorph methodsFor: 'construction' stamp: 'jens 3/25/2009 11:01'!
addIcon: aForm tooltip: aString target: target selector: aSymbol argumentList: argList
	"Append a menu item with the given label. If the item is selected, it will send the given selector to the target object with the given arguments. If the selector takes one more argument than the number of arguments in the given list, then the triggering event is supplied as as the last argument."

	| item |
	item _ MenuItemMorph new
		icon: aForm;
		contents: '';
		setBalloonText: aString;
		target: target;
		selector: aSymbol;
		arguments: argList asArray.
	self addMorphBack: item.
! !


!MVCMenuMorph class methodsFor: 'instance creation' stamp: 'jens 3/30/2009 23:37'!
from: aPopupMenu title: titleStringOrNil
	"Answer a MenuMorph constructed from the given PopUpMenu. Used to simulate MVC-style menus in a Morphic-only world." 

	| menu items lines selections labelString j emphasis forms icon |
	menu _ self new.
	aPopupMenu isHorizontal ifTrue: [menu orientation: #horizontal].
	titleStringOrNil ifNotNil: [
		titleStringOrNil isEmpty ifFalse: [menu addTitle: titleStringOrNil]].
	labelString _ aPopupMenu labelString.
	items _ labelString asString findTokens: String cr.

	forms _ aPopupMenu icons.
	forms ifNil: [forms _ Array empty ].
	(forms size = items size) ifFalse: [
		forms _ Array new: items size ].

	labelString isText ifTrue:
		["Pass along text emphasis if present"
		j _ 1.
		items _ items collect:
			[:item | j _ labelString asString findString: item startingAt: j.
			emphasis _ TextEmphasis new emphasisCode: (labelString emphasisAt: j).
			item asText addAttribute: emphasis]].
	lines _ aPopupMenu lineArray.
	lines ifNil: [lines _ #()].
	menu cancelValue: 0.
	selections _ (1 to: items size) asArray.

	ScratchTranslator isRTL & aPopupMenu isHorizontal
		ifTrue: [
			items size to: 1 by: -1 do: [:i |
				icon _ forms at: i.
				icon isNil
					ifTrue: [ menu add: (items at: i) action: (selections at: i) ]
					ifFalse: [ menu addIcon: icon first tooltip: icon second action: (selections at: i)].
				(lines includes: i) ifTrue: [menu addLine]]]
		ifFalse: [
			1 to: items size do: [:i |
				icon _ forms at: i.
				icon isNil
					ifTrue: [ menu add: (items at: i) action: (selections at: i) ]
					ifFalse: [ menu addIcon: icon first tooltip: icon second action: (selections at: i)].
				(lines includes: i) ifTrue: [menu addLine]]].

	(ScratchTranslator canRenderUnicode and:
	 [labelString notNil and: [labelString isUnicode or: [(UTF8 withAll: labelString) isMacRoman not]]])
		ifTrue: [menu convertItemsToUTF8].

	^ menu
! !


!PopUpMenu methodsFor: 'accessing' stamp: 'jens 3/26/2009 18:02'!
icons
	^Array empty! !

!PopUpMenu methodsFor: 'accessing' stamp: 'jens 3/26/2009 18:31'!
isHorizontal
	^false! !

!PopUpMenu methodsFor: 'basic control sequence' stamp: 'jens 3/30/2009 23:59'!
startUpWithCaption: captionOrNil at: location
	"Display the menu, with caption if supplied. Wait for the mouse button to go down,
	then track the selection as long as the button is pressed. When the button is released, 
	answer the index of the current selection, or zero if the mouse is not released over 
	any menu item. Location specifies the desired topLeft of the menu body rectangle."

	| maxHeight mm loc |
	maxHeight _ Display height*3//4.
	self frameHeight > maxHeight ifTrue:
		[^ self
			startUpSegmented: maxHeight
			withCaption: captionOrNil
			at: location].

	Smalltalk isMorphic
		ifTrue:[
			mm _ MVCMenuMorph from: self title: captionOrNil.
			loc _ location.
			self isHorizontal & ScratchTranslator isRTL ifTrue: [
				loc _ location - (mm width @ 0) ].

			selection _ Cursor normal showWhile:
				[ mm invokeAt: loc in: World].
			^ selection].

	frame ifNil: [self computeForm].
	Cursor normal showWhile:
		[self
			displayAt: location
			withCaption: captionOrNil
			during: [self controlActivity]].
	^ selection! !

