Morph subclass: #PaletteFrameHeadMorph
	instanceVariableNames: 'classChooser basics variables classes messages choice lastMsgChoice frame methodsClass '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements-UI'!

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 22:10'!
adjustToClass: aClass
	(aClass isKindOf: Metaclass)
		ifTrue: [
			(#instanceVars = choice)
				ifTrue: [choice _ #variables]]! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 00:25'!
allClasses
	choice _ #allClasses.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 20:29'!
arrangePanes

	| toggleWidth |
	toggleWidth _ self width - 6 // 2.

	basics 
		width: toggleWidth;
		position: self topLeft + 2;
		fitMorphs.

	messages 
		width: toggleWidth;
		position: basics left @ (basics bottom + 2);
		fitMorphs.

	variables 
		width: toggleWidth;
		position: (basics right + 2) @ (basics top);
		fitMorphs.

	classes 
		width: toggleWidth;
		position: (basics right + 2) @ (variables bottom + 2);
		fitMorphs.

	self height: messages bottom + 2 - self top! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 03:16'!
basics
	choice _ #basics.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 01:44'!
buildPanes

	basics _ ElementsToggleButtonMorph new
				target: self;
				selector: #basics;
				label: 'Basics';
				onColor: Color green twiceDarker darker offColor: color.

	variables _ ElementsDoubleToggleMorph new
				target: self;
				selector: #variables;
				chooser: #varMenu;
				label: 'Variables';
				onColor: Color blue darker offColor: color.

	classes _ ElementsDoubleToggleMorph new
				target: self;
				selector: #classes;
				chooser: #classMenu;
				label: 'Classes';
				onColor: Color magenta darker darker darker offColor: color.

	messages _ ElementsDoubleToggleMorph new
				target: self;
				selector: #messages;
				chooser: #chooseClassForMethods;
				label: 'Messages';
				onColor: Color orange darker darker offColor: color.

	self
		addMorph: basics;
		addMorph: variables;
		addMorph: classes;
		addMorph: messages
! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 03:24'!
choice
	^choice! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 12:49'!
chooseClassForMethods

	| menu packages pkg pkgMenu catMenu superc subc smenu currentClass |

	self messages.	

	packages _ Dictionary new.
	SystemOrganization categories asSortedCollection do: [:cat |
		pkg _ (cat asString findTokens: #( $- )) first.
		(packages includesKey: pkg)
			ifFalse: [ packages at: pkg put: OrderedCollection new].
		(packages at: pkg) add: cat].

	currentClass _ self currentMethodsClass.

	superc _ currentClass allSuperclasses.
	subc _ currentClass allSubclasses.

	menu _ MenuMorph new.

	menu defaultTarget: self.
	menu add: 'current class' action: #currentMessages.

	currentClass isMeta
		ifTrue: [ menu add: 'instance side' selector: #setMethodsClass: argument: currentClass theNonMetaClass]
		ifFalse: [ menu add: 'class side' selector: #setMethodsClass: argument: currentClass class].

	superc isEmpty ifFalse: [
		smenu _ MenuMorph new defaultTarget: self.
		superc do: [:eachClass |
			smenu add: eachClass printString selector: #setMethodsClass: argument: eachClass ].
		menu add: 'superclasses' subMenu: smenu ].

	subc isEmpty ifFalse: [
		smenu _ MenuMorph new defaultTarget: self.
		subc do: [:eachClass |
			smenu add: eachClass printString selector: #setMethodsClass: argument: eachClass ].
		menu add: 'subclasses' subMenu: smenu].

	menu addLine.

	packages keys asSortedCollection do: [:eachPkg |
		pkgMenu _ MenuMorph new.
		(packages at: eachPkg) asSortedCollection do: [: cat |
			catMenu _ self menuForCategory: cat.
			pkgMenu add: (SyntaxElementMorph wordsFrom: cat asString)
					subMenu: catMenu ].
		menu add: eachPkg subMenu: pkgMenu ].

	menu popUpNearHand! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 00:23'!
classMenu
	| menu |
	menu _ MenuMorph new.
	menu defaultTarget: self.
	menu defaultTarget: self.
	menu add: 'in package' action: #currentPackageClasses.
	menu add: 'all' action: #allClasses.
	menu popUpNearHand! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 21:40'!
classVars
	choice _ #classVars.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/8/2009 23:38'!
classes
	choice _ #currentPackageClasses.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:04'!
currentMessages
	choice _ #currentMessages.
	lastMsgChoice _ choice.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 23:05'!
currentMethodsClass

	^(self ownerThatIsA: ElementsPaletteFrameMorph) currentMethodsClass.
	! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 00:25'!
currentPackageClasses
	choice _ #currentPackageClasses.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 21:24'!
frame: aMorph
	frame _ aMorph! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 21:40'!
globalVars
	choice _ #globalVars.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:12'!
initialize
	super initialize.
	choice _ #basics.
	lastMsgChoice _ #currentMessages.
	color _ Color gray.
	self width: 180.
	self buildPanes.
	self arrangePanes.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 21:39'!
instanceVars
	choice _ #instanceVars.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 01:52'!
menuForCategory: categoryName

	|menu list submenu |
	menu _ MenuMorph new
				defaultTarget: self.
	list _ SystemOrganization listAtCategoryNamed: categoryName.
	list asSortedCollection do: [:eachClass|
		submenu _ MenuMorph new defaultTarget: self.
		submenu add: 'instance' selector: #setMethodsClass: argument: (Smalltalk classNamed: eachClass).
		submenu add: 'class' selector: #setMethodsClass: argument: (Smalltalk classNamed: eachClass) class.
		menu add: (SyntaxElementMorph wordsFrom: eachClass asString) subMenu: submenu].
	^menu
! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:05'!
messages
	choice _ lastMsgChoice.
	self refresh! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 01:56'!
methodsClass
	^methodsClass! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 14:33'!
refresh
	basics off.
	classes off.
	messages off.
	variables off.

	(#basics = choice) ifTrue: [
		basics on ].
	(#(allClasses currentPackageClasses) includes: choice) ifTrue: [
		classes on ].
	(#(variables instanceVars classVars globalVars) includes: choice) ifTrue: [
		variables on ].
	(#(currentMessages methodsClass) includes: choice) ifTrue: [
		messages on ].

	frame ifNotNil: [frame refresh]! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/9/2009 02:04'!
setMethodsClass: aClass
	choice _ #methodsClass.
	lastMsgChoice _ choice.
	methodsClass _ aClass.
	self refresh	! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/7/2009 21:48'!
varMenu
	| menu isClassSide |
	menu _ MenuMorph new.
	menu defaultTarget: self.
	isClassSide _ frame currentClass isKindOf: Metaclass.
	isClassSide ifFalse: [
		menu add: 'instance' action: #instanceVars ].
	menu add: 'class' action: #classVars.
	menu add: 'globals' action: #globalVars.
	menu popUpNearHand! !

!PaletteFrameHeadMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 03:16'!
variables
	choice _ #variables.
	self refresh! !
