Morph subclass: #SyntaxElementMorph
	instanceVariableNames: 'label name '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Elements'!

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/15/2009 23:29'!
aboutToBeGrabbedBy: aHand

	(owner isKindOf: ArgumentElementMorph)
		ifTrue: [owner removeContents. ^self ].
	(owner isKindOf: StepElementMorph)
		ifTrue: [owner removeNext. ^self].
	(owner isKindOf: MessageElementMorph)
		ifTrue: [owner removeCascadedElement: self. ^self].
	^ self


! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 23:36'!
asSmalltalk
	^''! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 11:27'!
borderColorDark
	^color twiceDarker! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 12:02'!
borderColorLight
	^color twiceLighter lighter! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 11:57'!
borderColorVeryDark
	^color twiceDarker darker! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 12:02'!
borderColorVeryLight
	^color twiceLighter twiceLighter lighter! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 21:40'!
borderWidth
	^1
! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 12:58'!
changed
	super changed! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 23:06'!
contextMenu

	^nil! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 19:45'!
drawOn: aCanvas 

	|r bw |
	bw _ self borderWidth.

	"border"
	"top"
	r _ Rectangle origin: ((self left + bw) @ self top) corner: (self right @ (self top + bw)).
	aCanvas fillRectangle: r color: self borderColorVeryLight.

	"left"
	r _ Rectangle origin: (self topLeft) corner: (self left + bw) @ (self bottom - bw).
	aCanvas fillRectangle: r color: self borderColorLight.

	"right"
	r _ Rectangle origin: ((self right - bw) @ (self top + bw)) corner: self bottomRight.
	aCanvas fillRectangle: r color: self borderColorDark.

	"bottom"
	r _ Rectangle origin: (self left @ (self bottom - bw)) corner: (self right - bw) @ self bottom.
	aCanvas fillRectangle: r color: self borderColorVeryDark.

	"body"
"	aCanvas fillRectangle: (Rectangle origin: (self topLeft + bw) corner: (self bottomRight - bw)) color: color"

	aCanvas fillRectangle: (Rectangle origin: (self topLeft + bw) corner: (self right - bw) @ (self center y - bw)) color: color twiceLighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw) @ (self center y - bw) corner: (self right - bw) @ (self center y)) color: color lighter.

	aCanvas fillRectangle: (Rectangle origin: (self left + bw @ (self center y)) corner: (self bottomRight - bw)) color: color

! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/2/2009 23:43'!
duplicate
	World activeHand addMorph: super fullCopy! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/13/2009 12:41'!
evaluate
	^Compiler evaluate: self asSmalltalk! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/11/2009 22:07'!
fit
	self extent: label extent + (self borderWidth * 2).
	self width: (self width + (self labelFont widthOf: $ )).
	label position: bounds center - (label extent // 2).
	(owner respondsTo: #fit)
		ifTrue: [owner fit]
! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 22:56'!
handlesMouseDown: evt
	"Return true if this morph wants to receive mouseDown events (i.e., mouseDown:, mouseMove:, mouseUp:). The default response is false; subclasses that implement mouse messages should override this to return true." 

	^ true! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 12:36'!
initialize
	super initialize.
	color _ Color red! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 23:18'!
invokeContextMenu
	|m choice|
	m _ self contextMenu.
	m ifNotNil: [
		choice _ m startUp.
		choice ifNotNil: [self perform: choice] ]! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/10/2009 00:43'!
isRenameable
	| editor |
	editor _ (self ownerThatIsA: ElementsMethodEditorMorph).
	^editor isNil
	! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 20:46'!
label
	^name
	"^label contents"! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/22/2009 23:47'!
label: aString

	name _ aString.
	label ifNil: [
		label _ StringMorph contents: '' font: self labelFont.
		label color: self labelColor.
		self addMorphFront: label].
	label contents: (self wordsFrom: name).
	self fit
! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 12:36'!
labelColor
	^Color white! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/13/2009 21:39'!
labelFont
	^StrikeFont fontName: 'Verdana' size: 10! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/14/2009 23:02'!
mouseDown: evt
	"Handle a mouse down event."

	evt rightButtonPressed
		ifTrue: [ ^self invokeContextMenu].
	self startDrag: evt
! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 21:29'!
name
	^name! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 00:50'!
representsNil
	^false! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: ' jens 1/8/2009 14:04'!
rootForGrabOf: aMorph
	"Allow myself to be extracted."

	(owner notNil and: [owner isPartsBin])
		ifTrue: [^ super rootForGrabOf: aMorph]
		ifFalse: [^ self].
! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 1/28/2009 00:40'!
showGeneratedSmalltalk
	"StringHolder new contents: self asSmalltalk; openLabel: self class printString"	
	self inform: self asSmalltalk! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/13/2009 12:53'!
showResult
	self inform: self evaluate printString! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 6/5/2009 00:16'!
throwAway
	self aboutToBeGrabbedBy: nil; delete! !

!SyntaxElementMorph methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 22:13'!
wordsFrom: camelCase
	^self class wordsFrom: camelCase! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SyntaxElementMorph class
	instanceVariableNames: ''!

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 20:38'!
classNameFrom: aUserString
	"answer a camel-cased uppercased String"

	^(aUserString allWordsCapitalized reject: [:c|
		c = $ ]) capitalized! !

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 6/4/2009 02:33'!
fromString: aString

	|strg method compiler|
	strg _ aString, '.^self'.
	compiler _ Compiler new.
	compiler from: (ReadStream on: strg)
		class: nil class
		context: nil
		notifying: nil.

	method _ compiler translate: (ReadStream on: strg) noPattern: true ifFail: nil.
	World activeHand attachMorph: method asElementFromText

	! !

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 01:19'!
isDecompilable: selector class: class

	|  original compiled text node|
	original _ class methodDict at: selector.
	text _ ((class decompilerClass new)
		decompile: selector in: class method: original) printString.
	node _ Compiler new 
		compile: text 
		in: class 
		notifying: nil 
		ifFail: [self inform: 'compilation failed'].
	compiled _ node generate: #(0 0 0 0).
	original = compiled
		ifFalse: [Transcript nextPut: $-].
	^original = compiled
		
		! !

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 20:42'!
objectNameFrom: aUserString
	"answer a camel-cased String beginning with a lowercase character"

	|ans|
	ans _ self classNameFrom: aUserString.
	ans at: 1 put: (ans at: 1) asLowercase.
	^ans! !

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/16/2009 20:55'!
selectorFrom: aUserString
	"answer a camel-cased Symbol beginning with a lowercase character"

	|ans ws char|
	ans _ self classNameFrom: aUserString.
	ans at: 1 put: (ans at: 1) asLowercase.
	ws _ WriteStream on: String new.
	1 to: ans size do: [:i|
		char _ ans at: i.
		(char isUppercase and: [ (ans at: i - 1) = ($:)])
			ifTrue: [ws nextPut: char asLowercase]
			ifFalse: [ws nextPut: char]].
	^ws contents asSymbol! !

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 1/30/2009 00:50'!
test
	1 even ifTrue:[] ifFalse:[^'yes']! !

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/2/2009 01:21'!
testAllMethods
	"SyntaxElementMorph testAllMethods"

	| eachClass methods original compiled element|
	Smalltalk classNames do: [: className |
		eachClass _ Smalltalk classNamed: className.
		methods _ eachClass methodDict.
		methods keysDo: [ :eachSelector|
			(self isDecompilable: eachSelector class: eachClass)
				ifTrue: [
					original _ methods at: eachSelector.
					element _ ((eachClass decompilerClass new)
						decompile: eachSelector 
						in: eachClass 
						method: original) asSyntaxElement.
					compiled _ element asCompiledMethodForClass: eachClass.
					original = compiled
						ifTrue: [Transcript show:'.']
						ifFalse: [Transcript cr; 
							show: className asString, ' -> ', 
								eachSelector printString; cr]]]]
		
		! !

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 1/29/2009 00:31'!
testAllOriginalMethods

	| eachClass methods original compiled text node|
	Smalltalk classNames do: [: className |
		eachClass _ Smalltalk classNamed: className.
		methods _ eachClass methodDict.
		methods keysDo: [ :eachSelector|
			original _ methods at: eachSelector.
			text _ ((eachClass decompilerClass new)
				decompile: eachSelector in: eachClass method: original) printString.
			node _ Compiler new 
				compile: text 
				in: eachClass 
				notifying: nil 
				ifFail: [self inform: 'compilation failed'].
			compiled _ node generate: #(0 0 0 0).
			original = compiled
				ifTrue: [Transcript show:'.']
				ifFalse: [Transcript cr; 
					show: className asString, ' -> ', 
						eachSelector printString; cr]]]
		
		! !

!SyntaxElementMorph class methodsFor: 'as yet unclassified' stamp: 'jens 2/4/2009 23:37'!
wordsFrom: camelCase
	| ws cap |
	
	cap _ camelCase first isUppercase.

	(camelCase = 'ifTrue')
		ifTrue: [^'yes'].
	(camelCase = 'ifFalse')
		ifTrue: [^'no '].
	(camelCase = '_')
		ifTrue: [^':='].

	ws _ WriteStream on: String new.

	camelCase do: [:c|
		c isUppercase 
			ifTrue: [ 
			ws nextPut: $ ; 
			nextPut: (cap ifTrue: [c] ifFalse: [c asLowercase ])]
			ifFalse: [ 
				ws nextPut: c.
				(c = ($:)) ifTrue: [ws nextPut: $ ]]].
	^ws contents
! !
