ReporterBlockMorph subclass: #ListContentsBlockMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Scratch-Blocks'!
!ListContentsBlockMorph commentStamp: '<historical>' prior: 0!
Reporter for the contents of a list.

CAUTION: This block's meaning has been re-defined in BYOB+lambda to point to the actual list itself, since lists are now first class members
!


!ListContentsBlockMorph methodsFor: 'all' stamp: 'jens 11/18/2008 09:40'!
addLabel
	"Add a label for my command and arguments. 
	This is the method that really creates the whole block."
	"Details: This overrides the superclass method to allow 
	using percent character in variable/list names"

	commandSpec ifNil: [^ self].
	self removeAllMorphs.
	self addMorphBack: (self labelMorphFor: commandSpec).
! !

!ListContentsBlockMorph methodsFor: 'all' stamp: 'jens 2/1/2010 00:30'!
asBlockTuple
	"Answer a tuple (Array) describing this block and its arguments."

	^ (Array new: 4)
		at: 1 put: #byob;
		at: 2 put: self rcvr;
		at: 3 put: #listNamed:;
		at: 4 put: commandSpec;
		yourself

! !

!ListContentsBlockMorph methodsFor: 'all' stamp: 'jens 7/21/2010 19:49'!
evaluateWithArgs: ignored

	^ receiver listNamed: commandSpec
! !

!ListContentsBlockMorph methodsFor: 'all' stamp: 'jm 5/6/2008 17:10'!
selectorAndArg

	^ Array with: selector with: commandSpec
! !

!ListContentsBlockMorph methodsFor: 'all' stamp: 'jens 1/19/2011 00:05'!
toggleWatcher
	"Toggle between hiding and showing a list watcher for this block."

	| listMorph stage |
"	listMorph _ receiver lists at: commandSpec ifAbsent: [^ self]."
	listMorph _ receiver listNamed: commandSpec ifNone: [^ self].
	listMorph owner
		ifNil: [
			(stage _ receiver ownerThatIsA: ScratchStageMorph) ifNil: [^ self].
			stage addMorph: listMorph.
			(stage bounds containsPoint: listMorph topLeft) ifFalse: [
				listMorph position: stage topLeft + 10].
			listMorph
				fixLayoutForNewLanguage;
				startStepping]
		ifNotNil: [
			listMorph delete].
! !


!ListContentsBlockMorph methodsFor: 'as yet unclassified' stamp: 'JM 9/8/2011 16:30'!
exportCodeWith: anExporter

	anExporter exportListBlockMorph: self.! !
